package com.casic.dcms.view.handle;

import android.content.Context;
import android.content.res.Configuration;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.AdapterView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.databinding.ActivityCaseHandledDetailBinding;
import com.casic.dcms.model.CaseDetailBean;
import com.casic.dcms.utils.MapHelper;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.ViewGroupKit;
import com.casic.dcms.view.BigImageActivity;
import com.casic.dcms.view.CaseProcessActivity;
import com.casic.dcms.vm.CaseViewModel;
import com.pengxh.androidx.lite.adapter.ReadOnlyImageAdapter;
import com.pengxh.androidx.lite.base.AndroidxBaseActivity;
import com.pengxh.androidx.lite.kit.ContextKit;
import com.pengxh.androidx.lite.kit.StringKit;
import com.pengxh.androidx.lite.utils.Constant;
import com.pengxh.androidx.lite.utils.LoadState;
import com.pengxh.androidx.lite.utils.LoadingDialog;
import com.shuyu.gsyvideoplayer.GSYVideoManager;
import com.shuyu.gsyvideoplayer.builder.GSYVideoOptionBuilder;
import com.shuyu.gsyvideoplayer.listener.GSYSampleCallBack;
import com.shuyu.gsyvideoplayer.listener.LockClickListener;
import com.shuyu.gsyvideoplayer.utils.OrientationUtils;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;


public class CaseHandledDetailActivity extends AndroidxBaseActivity<ActivityCaseHandledDetailBinding> {

    private final Context context = CaseHandledDetailActivity.this;
    private CaseViewModel caseViewModel;
    private CaseDetailBean.DataBean data = new CaseDetailBean.DataBean();
    private OrientationUtils orientationUtils;
    private boolean isPlay;
    private boolean isPause;

    @Override
    protected void setupTopBarLayout() {
        ViewGroupKit.initImmersionBar(binding.rootView, this, true, R.color.white);

        binding.titleBarLayout.titleView.setText("案卷处理详情");
        binding.titleBarLayout.leftBackView.setOnClickListener(v -> finish());
    }

    @Override
    protected void observeRequestState() {
        caseViewModel.loadState.observe(this, new Observer<LoadState>() {
            @Override
            public void onChanged(LoadState loadState) {
                if (loadState == LoadState.Loading) {
                    LoadingDialog.show(CaseHandledDetailActivity.this, "获取数据中...");
                } else {
                    LoadingDialog.dismiss();
                }
            }
        });
    }

    @Override
    protected void initOnCreate(@Nullable Bundle savedInstanceState) {
        orientationUtils = new OrientationUtils(this, binding.videoPlayerView);
        //初始化不打开外部的旋转
        orientationUtils.setEnable(false);

        String id = getIntent().getStringExtra(Constant.INTENT_PARAM_KEY);
        caseViewModel = new ViewModelProvider(this).get(CaseViewModel.class);
        caseViewModel.getCaseDetail(this, id);
        caseViewModel.caseDetailModel.observe(this, new Observer<CaseDetailBean>() {
            @Override
            public void onChanged(CaseDetailBean resultBean) {
                if (resultBean.getCode() == 200) {
                    data = resultBean.getData().get(0);
                    binding.caseNumberView.setText(data.getCaseid());
                    binding.caseHandleStatusView.setText(data.getCaseStateName());
                    binding.caseTypeView.setText(data.getEorcName());
                    binding.caseLargeTypeView.setText(data.getCasetypeName());
                    binding.caseSmallTypeView.setText(data.getCasetypeDetailName());
                    binding.caseCommunityView.setText(data.getCommunityName().equals("") ? "无更详细社区信息" : data.getCommunityName());
                    binding.casePlaceView.setText(data.getFieldintro());
                    binding.caseSituationView.setText(data.getDescription());

                    //最初始的案卷图片
                    String verifyImages = data.getFileIdVerify();
                    if (!TextUtils.isEmpty(verifyImages)) {
                        ArrayList<String> urls = new ArrayList<>();
                        String[] split = verifyImages.split(",");
                        for (String s : split) {
                            if (s.endsWith(".jpg") || s.contains(".jpeg") || s.contains(".png")) {
                                urls.add(StringHelper.appendCompleteURL(s));
                            }
                        }
                        ReadOnlyImageAdapter imageAdapter = new ReadOnlyImageAdapter(context, urls);
                        binding.imageGridView.setAdapter(imageAdapter);
                        //九宫格点击事件
                        binding.imageGridView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                            @Override
                            public void onItemClick(AdapterView<?> adapterView, View view, int position, long l) {
                                if (urls.get(position).isEmpty()) {
                                    StringKit.show(context, "图片加载失败，无法查看大图");
                                } else {
                                    ContextKit.navigatePageTo(context, BigImageActivity.class, position, urls);
                                }
                            }
                        });
                    }

                    //案卷处理时候上传的图片
                    String handleImages = data.getFileIdProcess();
                    if (!TextUtils.isEmpty(handleImages)) {
                        ArrayList<String> urls = new ArrayList<>();
                        String[] split = handleImages.split(",");
                        for (String s : split) {
                            if (s.contains("jpg") || s.contains("jpeg") || s.contains("png")) {
                                urls.add(StringHelper.appendCompleteURL(s));
                            }
                        }
                        ReadOnlyImageAdapter imageAdapter = new ReadOnlyImageAdapter(context, urls);
                        binding.handleGridView.setAdapter(imageAdapter);
                        //九宫格点击事件
                        binding.handleGridView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                            @Override
                            public void onItemClick(AdapterView<?> adapterView, View view, int position, long l) {
                                if (urls.get(position).isEmpty()) {
                                    StringKit.show(context, "图片加载失败，无法查看大图");
                                } else {
                                    ContextKit.navigatePageTo(context, BigImageActivity.class, position, urls);
                                }
                            }
                        });
                    }

                    //音频
                    String audioFile = data.getAudioIdVerify();
                    if (!TextUtils.isEmpty(audioFile)) {
                        binding.audioPlayerView.setVisibility(View.VISIBLE);
                        String url = StringHelper.appendCompleteURL(audioFile);
                        try {
                            binding.audioPlayerView.setAudioSource(new File(url));
                        } catch (IOException e) {
                            throw new RuntimeException(e);
                        }
                    }

                    //视频
                    String videoFile = data.getVideoIdVerify();
                    if (!TextUtils.isEmpty(videoFile)) {
                        binding.videoPlayerView.setVisibility(View.VISIBLE);
                        String videoUrl = StringHelper.appendCompleteURL(videoFile);
                        GSYVideoOptionBuilder videoOption = new GSYVideoOptionBuilder();
                        videoOption.setIsTouchWiget(true)
                                .setRotateViewAuto(false)
                                .setLockLand(false)
                                .setAutoFullWithSize(true)
                                .setShowFullAnimation(false)
                                .setNeedLockFull(true)
                                .setUrl(videoUrl)
                                .setCacheWithPlay(false)
                                .setVideoTitle(data.getDescription())
                                .setVideoAllCallBack(new GSYSampleCallBack() {
                                    @Override
                                    public void onPrepared(String url, Object... objects) {
                                        super.onPrepared(url, objects);
                                        //开始播放了才能旋转和全屏
                                        orientationUtils.setEnable(true);
                                        isPlay = true;
                                    }

                                    @Override
                                    public void onQuitFullscreen(String url, Object... objects) {
                                        super.onQuitFullscreen(url, objects);
                                        if (orientationUtils != null) {
                                            orientationUtils.backToProtVideo();
                                        }
                                    }
                                }).setLockClickListener(new LockClickListener() {
                                    @Override
                                    public void onClick(View view, boolean lock) {
                                        if (orientationUtils != null) {
                                            //配合下方的onConfigurationChanged
                                            orientationUtils.setEnable(!lock);
                                        }
                                    }
                                }).build(binding.videoPlayerView);
                        binding.videoPlayerView.getFullscreenButton().setOnClickListener(new View.OnClickListener() {
                            @Override
                            public void onClick(View v) {
                                //直接横屏
                                orientationUtils.resolveByClick();
                                binding.videoPlayerView.startWindowFullscreen(context, true, true);
                            }
                        });
                    }
                }
            }
        });
    }

    @Override
    protected void initEvent() {
        binding.locationMapView.setOnClickListener(v -> MapHelper.displayOnMap(context, data.getEorcName(), data.getLng(), data.getLat()));

        binding.handleLayout.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                ContextKit.navigatePageTo(context, CaseProcessActivity.class, data.getProcessId());
            }
        });
    }

    @Override
    public void onBackPressed() {
        if (orientationUtils != null) {
            orientationUtils.backToProtVideo();
        }
        if (GSYVideoManager.backFromWindowFull(this)) {
            return;
        }
        super.onBackPressed();
    }

    @Override
    protected void onPause() {
        binding.videoPlayerView.getCurrentPlayer().onVideoPause();
        super.onPause();
        isPause = true;
    }

    @Override
    protected void onResume() {
        binding.videoPlayerView.getCurrentPlayer().onVideoResume(false);
        super.onResume();
        isPause = false;
    }

    @Override
    protected void onDestroy() {
        if (isPlay) {
            binding.videoPlayerView.getCurrentPlayer().release();
        }
        if (orientationUtils != null) {
            orientationUtils.releaseListener();
        }
        super.onDestroy();
    }

    @Override
    public void onConfigurationChanged(@NonNull Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
        //如果旋转了就全屏
        if (isPlay && !isPause) {
            binding.videoPlayerView.onConfigurationChanged(this, newConfig, orientationUtils, true, true);
        }
    }
}